unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, iCoolKey;

type
    TTimerThread = class(TThread)
    private
        procedure UpdateForm();
    protected
        procedure Execute(); override;
    end;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    LblMouseX: TLabel;
    LblMouseY: TLabel;
    HotKey1: THotKey;
    HotKey2: THotKey;
    HotKey3: THotKey;
    HotKey4: THotKey;
    ImgUnLock: TImage;
    ImgMouse: TImage;
    LblTopLeftX: TLabel;
    LblTopLeftY: TLabel;
    LblBottomRightX: TLabel;
    LblBottomRightY: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    PnlLock: TPanel;
    Label1: TLabel;
    LblCancelKey: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HotKey1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FTimerThread: TTimerThread;
    FRect: TRect;
    FLocked: Boolean;
  private
    FCoolKeys: TCoolKeys;
    procedure RecTopLeft();
    procedure RecBottomRight();
    procedure Lock();
    procedure UnLock();
    procedure RegistKeys();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Menus, Types, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  w肵`u
procedure FlashDesktopCanvas(const R: TRect; const Interval: integer);
var
    DesktopDC: HDC;
    DesktopCanvas: TCanvas;
begin
    //  fXNgbṽfoCXReLXg擾
    DesktopDC := GetDC(0);
    if (DesktopDC <> INVALID_HANDLE_VALUE) then
    begin
        DesktopCanvas := TCanvas.Create;
        try
            //  O
            DesktopCanvas.Handle := DesktopDC;
            DesktopCanvas.Pen.Width := 3;
            DesktopCanvas.Pen.Mode := pmNotXor;

            //  fXNgbvɋ``(XOR)
            DesktopCanvas.Rectangle(R);
            //  ΂҂
            Sleep(Interval);
            //  fXNgbvɋ``(XOR)
            DesktopCanvas.Rectangle(R);
        finally
            //  fXNgbṽfoCXReLXgj
            DesktopCanvas.Free;
            ReleaseDC(0, DesktopDC);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  }EXʒuXV
procedure TTimerThread.UpdateForm();
begin
    with Form1 do
    begin
        LblMouseX.Tag := Mouse.CursorPos.X;
        LblMouseY.Tag := Mouse.CursorPos.Y;
        LblMouseX.Caption := Format('%4.4d', [LblMouseX.Tag]);
        LblMouseY.Caption := Format('%4.4d', [LblMouseY.Tag]);
    end;
end;

//-----------------------------------------------------------------------------
//  }EXʒu\pXbh{
procedure TTimerThread.Execute();
begin
    inherited;
    while not Terminated do
    begin
        Synchronize(UpdateForm);
        Sleep(1);
    end;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);

    //  }EXʒu\pXbhJn
    FTimerThread := TTimerThread.Create(True);
    FTimerThread.Resume();

    //  ߂`
    FRect := Rect(0, 0, 0, 0);

    //  V[gJbgtNX쐬
    FCoolKeys := TCoolKeys.Create();

    //  bNtO
    FLocked := False;

    //  t
    RegistKeys();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  V[gJbg
    FCoolKeys.Free();

    //  }EXʒu\pXbh~
    FTimerThread.Terminate();
    FTimerThread.Free();

    //  }EX߂܂܏I悤Ƃꍇ͉
    if (FLocked) then UnLock();
end;

//-----------------------------------------------------------------------------
//  ߂`̍}EẌʒuŎw肷
procedure TForm1.RecTopLeft();
begin
    if (not FLocked) then
    begin
        FRect.TopLeft := Mouse.CursorPos;

        LblTopLeftX.Tag := FRect.TopLeft.X;
        LblTopLeftY.Tag := FRect.TopLeft.Y;
        LblTopLeftX.Caption := Format('%4.4d', [LblTopLeftX.Tag]);
        LblTopLeftY.Caption := Format('%4.4d', [LblTopLeftY.Tag]);
    end;
end;

//-----------------------------------------------------------------------------
//  ߂`̉E}EẌʒuŎw肷
procedure TForm1.RecBottomRight();
begin
    if (not FLocked) then
    begin
        FRect.BottomRight := Mouse.CursorPos;

        LblBottomRightX.Tag := FRect.BottomRight.X;
        LblBottomRightY.Tag := FRect.BottomRight.Y;
        LblBottomRightX.Caption := Format('%4.4d', [LblBottomRightX.Tag]);
        LblBottomRightY.Caption := Format('%4.4d', [LblBottomRightY.Tag]);
    end;
end;

//-----------------------------------------------------------------------------
//  J[\
procedure TForm1.Lock();
begin
    if (FRect.Left <> FRect.Right) and (FRect.Top <> FRect.Bottom)
    and (FRect.Left < FRect.Right) and (FRect.Top < FRect.Bottom) then
    begin
        ClipCursor(@FRect);
        FLocked := True;
        LblCancelKey.Caption := 'To Unlock ' + ShortCutToText(HotKey4.HotKey);
        PnlLock.Show();
        FlashDesktopCanvas(FRect, 100);
    end;
end;

//-----------------------------------------------------------------------------
//  J[\
procedure TForm1.UnLock();
begin
    ClipCursor(nil);
    FLocked := False;
    PnlLock.Hide();
end;

//-----------------------------------------------------------------------------
//  V[gJbgɏt
procedure TForm1.RegistKeys();
var
    LState: TShiftState;
    LKey: Word;
    LIndex: Integer;
    LResult: Boolean;
begin
    FCoolKeys.Clear();
    LResult := True;

    ShortCutToKey(HotKey1.HotKey, LKey, LState);
    LIndex := FCoolKeys.Add(RecTopLeft, LState, LKey);
    if (LIndex < 0) then
    begin
        LResult := False;
    end;
    Image1.Visible := (LIndex < 0);

    ShortCutToKey(HotKey2.HotKey, LKey, LState);
    LIndex := FCoolKeys.Add(RecBottomRight, LState, LKey);
    if (LIndex < 0) then
    begin
        LResult := False;
    end;
    Image2.Visible := (LIndex < 0);

    ShortCutToKey(HotKey3.HotKey, LKey, LState);
    LIndex := FCoolKeys.Add(Lock, LState, LKey);
    if (LIndex < 0) then
    begin
        LResult := False;
    end;
    Image3.Visible := (LIndex < 0);

    ShortCutToKey(HotKey4.HotKey, LKey, LState);
    LIndex := FCoolKeys.Add(UnLock, LState, LKey);
    if (LIndex < 0) then
    begin
        LResult := False;
    end;
    Image4.Visible := (LIndex < 0);

    if (not LResult) then
    begin
        FCoolKeys.Clear();
        PageControl1.ActivePageIndex := 1;
    end;
end;

//-----------------------------------------------------------------------------
//  V[gJbgύXꂽo^Ȃ
procedure TForm1.HotKey1Change(Sender: TObject);
begin
    RegistKeys();
end;

//-----------------------------------------------------------------------------
//  \ʂ̉Eɓ
procedure TForm1.FormShow(Sender: TObject);
var
    R: TRect;
begin
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Self.Left := (R.Right - Self.Width);
    Self.Top := (R.Bottom - Self.Height);
end;

//-----------------------------------------------------------------------------
//  o[W\
procedure TForm1.Button1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
